from pymongo import MongoClient
from random import randrange


class UtilisateurDao:
    client = MongoClient('localhost', 27017)

    ## extraction d'une base de données. Si elle n'existe pas, elle esst créée
    base_donnees = client.squelette

    ## permet d'authentifier un utilisateur
    # (actuellement en version 'basique', sera mis aux normes ultérieurement)
    # @param nomUtilisateur le login tapé
    # @param motDePasse le mot de passe tapé
    # @return un booléen pour dire si l'utilisateur existe ou pas
    def presence_utilisateur(self, nomUtilisateur):
        # print("Je suis dans présence utilisateur pour ", nomUtilisateur)

        # print("Et j'en ai trouvé : ", nmbre.count())

        return self.base_donnees.utilisateur.count_documents({"nom": nomUtilisateur}) == 1

    ## Fonction de création d'un utilisateur
    # @param nomUtilisateur le nom de l'utilisateur à créer
    # @param(bientot) mot_de_passe le mdp de l'utilsateur à créer
    def ajouter_utilisateur(self, nom_utilisateur):
        self.base_donnees.utilisateur.insert_one(
            {"nom": nom_utilisateur, "note": randrange(0, 10, 1), "tiers": [], "tags": []})

    ## Fonction de récupération de tous les utilisateurs existants (pour le filtre)
    # @return les utilisateurs en base
    def get_all_utilisateurs(self):
        return self.base_donnees.utilisateur.find({}, {"nom": 1, "_id": 0})

    ## Fonction pour supprimer un utilisateur
    # @param nom_utilisateur le nom de l'utilisateur à supprimer
    def supprimer_utilisateur(self, nom_utilisateur):
        self.base_donnees.utilisateur.delete_one({"nom": nom_utilisateur})
